"""
Django settings for college_automation project.

Generated by 'django-admin startproject' using Django 1.9.8.

For more information on this file, see
https://docs.djangoproject.com/en/1.9/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.9/ref/settings/
"""

import os
# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
import sys

from django.http import HttpRequest

BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.9/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = '%48ly36pl6)2ccj!l*-%5qy-y3y%(x!p#!e^%pv3$l^j_ypl3g'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = []

################# Variable to hide features during development  ##############

HIDE_THIS_FEATURE = True

################## DB BACUP SETTINGS ####################

# DBBACKUP_STORAGE = 'storages.backends.dropbox.DropBoxStorage'
# DBBACKUP_STORAGE_OPTIONS = {
#     'oauth2_access_token': 'HpSJrshd_UAAAAAAAAAA68sx47Qx8Xm5US4GCENt9wK-d2wi1GMTthqZy9yHZcgk',
# }


DBBACKUP_STORAGE = 'django.core.files.storage.FileSystemStorage'
DBBACKUP_STORAGE_OPTIONS = {'location': '/home/ubuntu/dbbackup'}

#########################################################

# Application definition

INSTALLED_APPS = [
    'accounts',
    'curriculum',
    'messaging',
    'marks',
    'quiz',
    'wifi',
    'hostel',
    'developers',
    'system',
    'alumni',
    'enrollment',
    'assignment',
    'feedback',
    'attendance',
    'courseOutcomes',
    'departmentManagement',
    'integrations',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'dbbackup',
    'easy_pdf',
    'dashboard',
    'simple_history',
    'notifications',
    'oauth2_provider',
    'rest_framework',
]
#################### AUTH #######################

AUTH_USER_MODEL = 'accounts.customUser'
AUTHENTICATION_BACKENDS = ('accounts.backends.CustomUserAuth', 'django.contrib.auth.backends.ModelBackend')
NOTIFICATIONS_USE_JSONFIELD = True
NOTIFICATIONS_SOFT_DELETE = True
##################################################

#################### LOGIN ##############################
LOGIN_URL = '/login'
LOGIN_REDIRECT_URL = '/dashboard/'
#########################################################

##################### TEST RUNNER #############################

################################################################

MIDDLEWARE_CLASSES = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'simple_history.middleware.HistoryRequestMiddleware'
]

# for mailing

EMAIL_BACKEND = 'django.core.mail.backends.console.EmailBackend'
CURRENT_HOST_NAME = 'http://127.0.0.1:8000/'

ROOT_URLCONF = 'college_automation.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'college_automation.wsgi.application'

# Database
# https://docs.djangoproject.com/en/1.9/ref/settings/#databases

# configuring mysql python3: http://stackoverflow.com/questions/13320343/can-i-use-mysql-on-djangodev-1-6-x-with-python3-x


"""
DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.mysql',
        'NAME': 'ca_production_db',
        'USER': 'root',
        'HOST': 'localhost',
        'PORT': '3306',
    }
}
"""
"""

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.mysql',
        'NAME': 'ca_development_db',
        'USER': 'test_db_user',
        'PASSWORD': 'test#1234',
        'HOST': '117.239.246.58',
        'PORT': '3306',
        'OPTIONS': {'init_command': "SET sql_mode='STRICT_TRANS_TABLES'"}
    }
}
"""

import configparser
config = configparser.ConfigParser()
config.read(os.path.join(BASE_DIR, 'config.ini'))

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.mysql',
        'NAME': config['PRODUCTION']['PRODUTION_DB_NAME'],
        'USER': config['PRODUCTION']['PRODUTION_DB_USER_NAME'],
        'PASSWORD': config['PRODUCTION']['PRODUTION_DB_PASSWORD'],
        'HOST': config['PRODUCTION']['PRODUTION_DB_HOST'],
        'PORT': config['PRODUCTION']['PRODUTION_DB_PORT'],
        'OPTIONS': {'init_command': "SET sql_mode='STRICT_TRANS_TABLES'"}
    }
}
"""

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': 'mydatabase'
    },
}
"""
if 'test' in sys.argv:
    DATABASES['default'] = {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': 'mytestdb'
    }
TESTING = len(sys.argv) > 1 and sys.argv[1] == 'test'
if TESTING:
    print('=========================')
    print('In TEST Mode - Disableling Migrations')
    print('=========================')

    class DisableMigrations(object):

        def __contains__(self, item):
            return True

        def __getitem__(self, item):
            return "notmigrations"

    MIGRATION_MODULES = DisableMigrations()
# https://docs.djangoproject.com/en/1.9/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Internationalization
# https://docs.djangoproject.com/en/1.9/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Asia/Kolkata'

USE_I18N = True

USE_L10N = True

USE_TZ = False

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.9/howto/static-files/a



STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, "static/")
MEDIA_ROOT = os.path.join(BASE_DIR, "media/")
MEDIA_URL = '/media/'

#onesignal
ONESIGNAL_APP_API_ID = 'c616190e-5cde-41fb-a1cc-b92441460e59'
ONESIGNAL_REST_API_KEY = 'MzU5OTI0Y2EtYjY5Yy00YTJhLTkwMDktNDRmOTkzMWNkMjdh'
ENABLE_ONESIGNAL_NOTIFICATIONS = True


############################## REST FRAMEWORK #####################################

REST_FRAMEWORK = {
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'oauth2_provider.ext.rest_framework.OAuth2Authentication',
    ),
    'DEFAULT_PERMISSION_CLASSES': (
        'rest_framework.permissions.IsAuthenticated',
    )
}

###################################################################################


############################## LOGGING #############################################

# LOGGING = {
#     'version': 1,
#     'formatters': {
#         'verbose': {
#             'format': '%(levelname)s %(asctime)s %(module)s %(process)d %(thread)d %(message)s'
#         },
#         'simple': {
#             'format': '%(levelname)s %(message)s'
#         },
#     },
#     'handlers': {
#         'console': {
#             'level': 'INFO',
#             'class': 'logging.StreamHandler',
#             'formatter': 'simple'
#         },
#         # 'file': {
#         #     'level': 'DEBUG',
#         #     'class': 'logging.FileHandler',
#         #     'filename': '/path/to/your/file.log',
#         #     'formatter': 'simple'
#         # },
#     },
#     'loggers': {
#         'django': {
#             'handlers': ['console'],
#             'level': 'INFO',
#             'propagate': True,
#         },
#     }
# }
#
# if DEBUG:
#     # make all loggers use the console.
#     for logger in LOGGING['loggers']:
#         LOGGING['loggers'][logger]['handlers'] = ['console']

#######################################################################################
